/* --------------------------------------------------------------  */
/* (C)Copyright 2008                                               */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#include <sys/time.h>
#include <time.h>

/* Time Funcs */
#define TDS_RB()   gettimeofday(&begin, NULL)
#define TDS_RE()   gettimeofday(&end, NULL)
#define TDS_RGET() ((double)(end.tv_sec -begin.tv_sec) + (double)(end.tv_usec -begin.tv_usec) /1E6 )

#define MIN(a, b) (((a) > (b)) ? (b) : (a))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))
#define ABS(a) (((a) >= 0) ? (a) : (-(a)))
#define FILELINE 128

#define _DEBUG

extern double dlamch_(char*);

extern int dgemm_(char *transa, char *transb, int *m, int *n, \
                  int *k, double *alpha, double *a, int *lda, double *b, \
                  int *ldb, double *beta, double *c, int *ldc);

#define dgemm dgemm_

extern void dlaset_(char *uplo, int *m, int *n, double *alpha, double *beta, double *a, int *lda);

extern double dlange_(char*, int*, int*, double*, int*, double*);

double dlansy(char *uplo, int *n, double *p_A, int *lda, double *p_work, int kx);

void dort01(char *rowcol, int *m, int *n, double *U, int *ldu, \
            double *work, double *resid);

void dbdt01(int *m, int *n, double *p_A, int *lda, double *p_U, int *ldu, double *p_S, double *p_VT, \
            int *ldvt, double *p_work, double *resid);

void verify(int m, int n, double *A, int lda, double *U, int ldu, double *S, double *VT, int ldvt);
